﻿$(document).ready(function () {
    $("#dialog-confirm-delete-ticket-relation").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    $.ajax({
                        url: RQ_URL + "/Chat/DeleteTicketRelation",
                        type: "POST",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        data: JSON.stringify({
                            id: chatSessionId,
                            ticketId: ticketId,
                        }),
                        success: function () {
                            ReloadTickets();
                        },
                        error: function (error) { alert(error.responseText); },
                    });
                    $(this).dialog("close");
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });
    
    $("#dialog-chatTicketRelation").dialog({
        autoOpen: false,
        resizable: false,
        width: "900",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Save,
                click: function () {
                    $.ajax({
                        url: RQ_URL + "/Chat/CreateTicketRelation",
                        type: "POST",
                        dataType: "json",
                        contentType: "application/json; charset=utf-8",
                        data: JSON.stringify({
                            id: chatSessionId,
                            ticketIds: $("#ChatSessionTicket").val(),
                        }),
                        success: function () {
                            ReloadTickets();
                        },
                        error: function (error) { alert(error.responseText); },
                    });
                    $(this).dialog("close");
                }
            },
            {
                text: Localization_Close,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $("#dialog-chatUserRelation").dialog({
        autoOpen: false,
        resizable: false,
        width: "500",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Save,
                click: function () {

                    var userProviderKey = $('#ddlChatUser').val();

                    if (userProviderKey == null || !userProviderKey.trim()) {
                        $('#lbErrorNoUser').show();
                    }
                    else {
                        $('#lbErrorNoUser').hide();

                        $.post(
                            RQ_URL + "/Chat/SetUserRelation",
                            {
                                chatSessionId: chatSessionId,
                                userProviderKey: userProviderKey,
                            },
                            function (data) {
                                location.reload();
                            },
                            "json"
                            )
                            .fail(function (error) { alert(error.responseText); })
                            .done(function () { $("#dialog-chatUserRelation").dialog("close"); });
                    }
                }
            },
            {
                text: Localization_Close,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $('.bt-set-chat-user').click(function () {
        $('#lbErrorNoUser').hide();
        $('#ddlChatUser').val('').trigger('change');
        $("#dialog-chatUserRelation").dialog('open');
    });

    $("#ddlChatUser").select2({
        width: '100%',
        minimumInputLength: 0,
        placeholder: Localization_Search,
        ajax: {
            url: RQ_URL + '/Account/UsersForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 10,
                    pageNum: params.page || 1,
                    term: params.term,
                    showEmail: true,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: true,
        },
        escapeMarkup: function (markup) { return markup; },
        templateResult: formatUsersForSelect2AjaxData,
        templateSelection: formatUsersForSelect2AjaxElement,
    });

    $("#ddlChatUser").change(function () {
        $('#lbErrorNoUser').hide();
    });

    $('.bt-delete-chat-user').click(function () {
        $("#dialog-confirm-delete-user-relation").dialog('open');
    });

    $("#dialog-confirm-delete-user-relation").dialog({
        autoOpen: false,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
        buttons: [
            {
                text: Localization_Yes,
                click: function () {
                    $.post(
                        RQ_URL + "/Chat/DeleteUserRelation",
                        {
                            chatSessionId: chatSessionId,
                        },
                        function (data) {
                            location.reload();
                        },
                        "json"
                        )
                        .fail(function (error) { alert(error.responseText); })
                        .done(function () { $("#dialog-confirm-delete-user-relation").dialog("close"); });
                }
            },
            {
                text: Localization_No,
                click: function () {
                    $(this).dialog("close");
                }
            }
        ]
    });

    $('button.set-as-requester').click(function () {
        var userProviderKey = $(this).closest('tr').data('user-provider-key');

        $.post(
            RQ_URL + "/Chat/SetUserRelation",
            {
                chatSessionId: chatSessionId,
                userProviderKey: userProviderKey,
            },
            function (data) {
                location.reload();
            },
            "json"
            )
            .fail(function (error) { alert(error.responseText); })
            .done(function () {  });
    });

    $('.bt-add-new-user').click(function () {
        AddUser();
    });

    //messages colors
    $(".chat-message-container > svg.chat-message-triangle > polygon").css("stroke", function () { return tinycolor($(this).css("fill")).darken(); });
    $(".chat-message-container > .chat-message-bubble").css("border-color", function () { return tinycolor($(this).css("background-color")).darken(); });
    $(".chat-message-container > .chat-message-bubble > .chat-message-header > b > span.chat-message-header-name, .chat-message-container > .chat-message-bubble > .chat-message-header > span.chat-message-header-time").css("color", function () {
        return chatUtils.getChatMessageHeaderTextColor($(this).closest(".chat-message-bubble").find(".chat-common-message-body > p, .chat-attachments-message-body > i").css("color"), $(this).closest(".chat-message-bubble").css("background-color")).toHexString();
    });

}); //end document ready

function OpenChatTicketRelation() {
    $("#ChatSessionTicket").val([]).trigger('change');
    $("#dialog-chatTicketRelation").html("<div class='loading-32'></div>");
    $("#dialog-chatTicketRelation").dialog("open");
    $("#dialog-chatTicketRelation").load(RQ_URL + "/Chat/ChatTicketRelation/" + chatSessionId, function () {
        $("#dialog-chatTicketRelation").dialog("close");
        $("#dialog-chatTicketRelation").dialog("open");
    });
}

function ReloadTickets() {
    $("#Tickets").html("<div class='loading-32'></div>");
    $("#Tickets").load(RQ_URL + "/Chat/ReloadRelationShipsWithTicket/" + chatSessionId);
}

var ticketId = -1;
function DeleteRelationShip(tId) {
    ticketId = tId;
    $("#dialog-confirm-delete-ticket-relation").dialog("open");
}

function AddUser() {
    $("#dialogAddNewUser").html("<div class='loading-32'></div>");

    $("#dialogAddNewUser").dialog({
        autoOpen: true,
        resizable: false,
        width: "auto",
        height: "auto",
        modal: true,
    });

    $("#dialogAddNewUser").load(RQ_URL + "/Account/RegisterUserDialogPartial", function () {
        Select2Combos();
        $("#dialogAddNewUser").dialog("close");

        $("#dialogAddNewUser").dialog({
            autoOpen: true,
            resizable: false,
            width: 850,
            height: "auto",
            modal: true,
            buttons: [
                {
                    text: Localization_Create,
                    click: function () {
                        $('#formRegisterUser').submit();
                    }
                },
                {
                    text: Localization_Cancel,
                    click: function () {
                        $(this).dialog("close");
                    }
                }
            ]
        });
    });
}

function OnRegisterUserSuccess(result) {
    if (result.success) {
        $("#dialogAddNewUser").dialog("close");
        $("#dialogAddNewUserComplete").html(result.html); //continue to next form
        $("#dialogAddNewUserComplete").dialog({
            autoOpen: true,
            resizable: false,
            width: 550,
            height: "auto",
            modal: true,
            buttons: [
                {
                    text: Localization_Select,
                    click: function () {
                        $(this).dialog("close");

                        $.post(
                            RQ_URL + "/Chat/SetUserRelation",
                            {
                                chatSessionId: chatSessionId,
                                userProviderKey: result.user.id,
                            },
                            function (data) {
                                location.reload();
                            },
                            "json"
                            )
                            .fail(function (error) { alert(error.responseText); })
                            .done(function () { $("#dialog-chatUserRelation").dialog("close"); });
                    }
                }
            ]
        });
    }
    else {
        $('#dialogAddNewUser').html(result); //some form errors, redisplay form
    }
}