﻿////////////  proměné se inicializují v cshtml /////////////////

function initSelect2Tags(selector) {
    $(selector).select2({
        minimumInputLength: 0,
        width: '100%',
        tags: true,
        templateSelection: formatState,
        dropdownCssClass: "select2-hide-selected-items-in-dropdown",
        placeholder: Localization_AddTag,
        ajax: {
            url: RQ_URL + '/Admin/Tags/TagsForSelect2Ajax',
            type: "POST",
            dataType: 'json',
            delay: 250,
            data: function (params) {
                return {
                    pageSize: 20,
                    pageNum: params.page || 1,
                    term: params.term,
                    type: tagType,
                };
            },
            processResults: function (data, params) {
                params.page = data.PageNum;

                return {
                    results: data.Results,
                    pagination: {
                        more: (data.PageNum * data.PageSize) < data.Total
                    }
                };
            },
            cache: false,
        },
        createTag: function (tag) {
            var found = true;
            $.ajax({
                url: RQ_URL + "/Admin/Tags/CheckTag",
                type: "POST",
                async: false,
                data: JSON.stringify({
                    text: tag.term,
                    type: tagType,
                }),
                dataType: "json",
                contentType: "application/json; charset=utf-8",
                success: function (g) {
                    // check if the option is already there
                    found = g;
                },
                error: function (error) { alert(error.responseText); },
                complete: function () {
                }
            });

            // show the suggestion only if a match was not found
            if (!found) {
                return {
                    id: tag.term.toLowerCase(),
                    text: tag.term,
                    isNew: true
                };
            }
        }
    }).change(function () {
        setColorInSelect2Tag();
    });
    if (typeof selectedTags !== 'undefined') {
        $(selector).val(selectedTags).trigger("change");
    }
}

function formatState (state) {
    if (!state.id) { return state.text; }
    var color = state.color;
    var textcolor = state.textcolor;
    var bordercolor = state.bordercolor;
    if(bordercolor == undefined) {
        bordercolor = "#a8a8a8";
    }
    if(textcolor == undefined) {
        textcolor = "black";
    }
    if(color == undefined) {
        color = "#f0f0f0";
    }
    for(var i = 0;i<selectedTagsData.length;i++)
    {
        if(selectedTagsData[i].id == state.id)
        {
            color = selectedTagsData[i].color;
            textcolor = selectedTagsData[i].textcolor;
            bordercolor = selectedTagsData[i].bordercolor;
        }
    }
    var $state = $(
      '<span data-select2bordercolor="'+bordercolor+'" data-select2color="'+color+'" style="color:'+textcolor+'" >' + state.text + '</span>'
    );
    return $state.data("select2color", color).data("select2bordercolor", bordercolor);
}

function setColorInSelect2Tag(){
    $(':data(select2color)').each(function() {
        var element = $(this);
        element.parent().css("border-color", element.attr("data-select2bordercolor"));
        element.parent().css("background-color", element.attr("data-select2color"));
    });
}