﻿// moment.js language configuration
// language : Slovakia slovak (sk-SK)
// author : Ondrej Kanecka //not posted GitHub
(function () {
    var lang = {
        months: "leden_únor_březen_duben_květen_červen_červenec_srpen_září_říjen_listopad_prosinec".split("_"),
        monthsShort: "Led_Úno_Bře_Dub_Kvě_Čer_Čec_Srp_Zář_Říj_Lis_Pro".split("_"),
        weekdays: "neděle_pondělí_úterý_středa_čtvrtek_pátek_sobota".split("_"),
        weekdaysShort: "ned_pon_úte_stř_čtv_pát_sob".split("_"),
        weekdaysMin: "Ne_Po_Út_St_Čt_Pá_So".split("_"),
        longDateFormat: {
            LT: "H:mm",
            L: "DD.MM.YYYY",
            LL: "D. MMMM YYYY",
            LLL: "D. MMMM YYYY LT",
            LLLL: "dddd, D. MMMM YYYY LT",
            LTS: "H:mm:ss"
        },
        calendar: {
            sameDay: '[dnes v] LT',
            nextDay: '[zítra v] LT',
            nextWeek: 'dddd [v] LT',
            lastDay: '[včera v] LT',
            lastWeek: 'L', //'[poslední] dddd [v] LT',
            sameElse: 'L'
        },
        relativeTime: {
            future: "za %s",
            past: "před %s",
            s: function (number, withoutSuffix, key, isFuture) {
                return withoutSuffix || isFuture ? "pár sekund" : "pár sekundami";
            },
            m: function (number, withoutSuffix, key, isFuture) {
                return withoutSuffix ? "minuta" : isFuture ? "minutu" : "minutou";
            },
            mm: function (number, withoutSuffix, key, isFuture) {
                return number + " " + (withoutSuffix || isFuture ? number < 5 ? "minuty" : "minut" : "minutami");
            },
            h: function (number, withoutSuffix, key, isFuture) {
                return withoutSuffix ? "hodina" : isFuture ? "hodinu" : "hodinou";
            },
            hh: function (number, withoutSuffix, key, isFuture) {
                return number + " " + (withoutSuffix || isFuture ? number < 5 ? "hodiny" : "hodin" : "hodinami");
            },
            d: function (number, withoutSuffix, key, isFuture) {
                return withoutSuffix || isFuture ? "den" : "dnem";
            },
            dd: function (number, withoutSuffix, key, isFuture) {
                return number + " " + (number < 5 || !isFuture && !withoutSuffix ? "dny" : "dnů");
            },
            M: function (number, withoutSuffix, key, isFuture) {
                return withoutSuffix || isFuture ? "měsíc" : "měsícem";
            },
            MM: function (number, withoutSuffix, key, isFuture) {
                return number + " " + (withoutSuffix || isFuture ? number < 5 ? "měsíce" : "měsíců" : "měsíci");
            },
            y: function (number, withoutSuffix, key, isFuture) {
                return withoutSuffix || isFuture ? "rok" : "rokem";
            },
            yy: function (number, withoutSuffix, key, isFuture) {
                return number + " " + (number < 5 || !isFuture && !withoutSuffix ? "roky" : "roků");
            }
        },
        ordinal: function (number) {
            return '.';
        }
    };

    // Node
    if (typeof module !== 'undefined' && module.exports) {
        module.exports = lang;
    }
    // Browser
    if (typeof window !== 'undefined' && this.moment && this.moment.locale) {
        this.moment.locale('sk', lang);
    }
}());